<template xmlns=''>
  <a-card :bordered='false'>
    <!-- 查询区域 -->
    <div class='table-page-search-wrapper'>
      <a-form layout='inline' @keyup.enter.native='searchQuery'>
        <a-row :gutter='24'>
          <!-- <a-col :xl='6' :lg='7' :md='8' :sm='24'>
            <a-form-item label='名称'>
              <a-input placeholder='请输入名称' v-model='queryParam.name'></a-input>
            </a-form-item>
          </a-col> -->
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
              <a-form-item label="委托单位">
                <a-select
                v-model="queryParam.weituoClient"
                placeholder="请选择委托单位"
                show-search
                allowClear
                :options="weituoClientOptions"
                @change="getWeituoClientOptions">
                </a-select>
              </a-form-item>
          </a-col>
          <a-col :xl="6" :lg="7" :md="8" :sm="24">
              <a-form-item label="委托编号">
                <a-select
                v-model="queryParam.weituoNo"
                placeholder="请选择委托编号"
                show-search
                allowClear
                :options="weituoNoOptions"
                @change="getWeituoNo">
                </a-select>
              </a-form-item>
          </a-col>
          <a-col :xl='6' :lg='7' :md='8' :sm='24'>
            <a-form-item label='发起人'>
              <j-select-user-by-dep placeholder='请选择发起人' v-model='queryParam.faqiUser' />
            </a-form-item>
          </a-col>
          <a-col :xl='6' :lg='7' :md='8' :sm='24'>
            <span style='float: left;overflow: hidden;' class='table-page-search-submitButtons'>
              <a-button type='primary' @click='searchQuery' icon='search'>查询</a-button>
              <a-button type='primary' @click='searchReset' icon='reload' style='margin-left: 8px'>重置</a-button>

            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>
    <!-- 查询区域-END -->

    <!-- 操作按钮区域 -->
    <div class='table-operator'>
      <a-button @click='handleAdd' type='primary' icon='plus'>新增</a-button>
      <a-button @click='exportJX' v-has="'jixiao:exportXls'" type='primary' icon='download'>绩效导出</a-button>
      <!-- <a-button type='primary' icon='download' @click="handleExportXls('运行流程表')">导出</a-button>
      <a-upload name='file' :showUploadList='false' :multiple='false' :headers='tokenHeader' :action='importExcelUrl'
                @change='handleImportExcel'>
        <a-button type='primary' icon='import'>导入</a-button>
      </a-upload> -->
      <!-- 高级查询区域 -->
      <!-- <j-super-query :fieldList='superFieldList' ref='superQueryModal'
                     @handleSuperQuery='handleSuperQuery'></j-super-query> -->
      <a-dropdown v-if='selectedRowKeys.length > 0'>
        <a-menu slot='overlay'>
          <a-menu-item key='1' @click='batchDel'>
            <a-icon type='delete' />
            删除
          </a-menu-item>
        </a-menu>
        <a-button style='margin-left: 8px'> 批量操作
          <a-icon type='down' />
        </a-button>
      </a-dropdown>
    </div>

    <!-- table区域-begin -->
    <div>
      <div class='ant-alert ant-alert-info' style='margin-bottom: 16px;'>
        <i class='anticon anticon-info-circle ant-alert-icon'></i> 已选择 <a
        style='font-weight: 600'>{{ selectedRowKeys.length }}</a>项
        <a style='margin-left: 24px' @click='onClearSelected'>清空</a>
      </div>

      <a-table
        ref='table'
        size='middle'
        :scroll='{x:true}'
        bordered
        rowKey='id'
        :columns='columns'
        :dataSource='dataSource'
        :pagination='ipagination'
        :loading='loading'
        :rowSelection='{selectedRowKeys: selectedRowKeys, onChange: onSelectChange}'
        class='j-table-force-nowrap'
        @change='handleTableChange'>

        <template slot='htmlSlot' slot-scope='text'>
          <div v-html='text'></div>
        </template>
        <template slot='imgSlot' slot-scope='text,record'>
          <span v-if='!text' style='font-size: 12px;font-style: italic;'>无图片</span>
          <img v-else :src='getImgView(text)' :preview='record.id' height='25px' alt=''
               style='max-width:80px;font-size: 12px;font-style: italic;' />
        </template>
        <template slot='fileSlot' slot-scope='text'>
          <span v-if='!text' style='font-size: 12px;font-style: italic;'>无文件</span>
          <a-button
            v-else
            :ghost='true'
            type='primary'
            icon='download'
            size='small'
            @click='downloadFile(text)'>
            下载
          </a-button>
        </template>

        <span slot='action' slot-scope='text, record'>
          <!-- <a-popconfirm v-show='record.isokview===true&&record.status==="0"' title="是否通过?" @confirm="() => tongguo(record) ">
            <a>下一步</a>
          </a-popconfirm> -->
          <a v-show='record.isokview===true&&record.status==="0"' @click='tongguo(record)'>下一步</a>
          <a-divider v-show='record.isokview===true&&record.status==="0"' type='vertical' />
          <a v-show='record.isbohuiview===true&&record.status==="0"' @click='bohui(record)'>驳回</a>
          <a-divider  v-show='record.isbohuiview===true&&record.status==="0"' type='vertical' />
          <a v-show='record.isbohuiview===true&&record.status==="0"' @click='bohui1(record)'>驳回指定节点</a>
          <a-divider v-show='record.isbohuiview===true&&record.status==="0"' type='vertical' />
          <!-- <a @click='handleEdit(record)'>编辑</a> -->
          <a @click='handleEdit2(record)'>流程编辑</a>

          <a-divider type='vertical' />
          <a-dropdown>
            <a class='ant-dropdown-link'>更多 <a-icon type='down' /></a>
            <a-menu slot='overlay'>
              <a-menu-item>
                <a @click='handleDetail(record)'>详情</a>
              </a-menu-item>
              <a-menu-item>
                <a-popconfirm title='确定删除吗?' @confirm='() => handleDelete(record.id)'>
                  <a>删除</a>
                </a-popconfirm>
              </a-menu-item>
            </a-menu>
          </a-dropdown>
        </span>

      </a-table>
    </div>

    <itdm-run-flow-path-modal ref='modalForm' @ok='modalFormOk'></itdm-run-flow-path-modal>
    <itdm-run-flow-path-shenhel ref='bohuiForm' @ok='modalFormOk'></itdm-run-flow-path-shenhel>
    <itdm-run-flow-path-shenhel1 ref='bohuiForm1' @ok='modalFormOk'></itdm-run-flow-path-shenhel1>



    <!-- 选择下一步责任人 -->
    <itdm-next-modal ref='nextChoose' @ok='modalFormOk' :fatherMethod="loadData"></itdm-next-modal>
    <!-- 导出绩效 -->
    <itdm-export-modal ref='exportJx' @ok='modalFormOk' :fatherMethod="loadData"></itdm-export-modal>



  </a-card>
</template>

<script>

import '@/assets/less/TableExpand.less'
import { mixinDevice } from '@/utils/mixin'
import { JeecgListMixin } from '@/mixins/JeecgListMixin'
import ItdmRunFlowPathModal from './modules/ItdmRunFlowPathModal'
import { filterMultiDictText } from '@/components/dict/JDictSelectUtil'
import { queryFlowPathSelectList, runFlowPathPass1, getWeituoClientList, getWeituoInfoListByClient, getNextTF } from '@api/api'
import { Modal } from 'ant-design-vue'
import ItdmRunFlowPathShenhel from './modules/ItdmRunFlowPathShenhel.vue'
import ItdmRunFlowPathShenhel1 from './modules/ItdmRunFlowPathShenhel1.vue'
import { deleteAction, getAction,downFile,getFileAccessHttpUrl } from '@/api/manage'
import ItdmNextModal from './modules/ItdmNextModal.vue'
import ItdmExportModal from './modules/ItdmExportModal.vue'
import { getYeWU, jixiaoPersonPrice } from '@/api/api'

export default {
  name: 'ItdmRunFlowPathList',
  mixins: [JeecgListMixin, mixinDevice],
  components: {
    ItdmRunFlowPathModal,ItdmRunFlowPathShenhel,ItdmRunFlowPathShenhel1,
    ItdmNextModal,
    ItdmExportModal
  },
  data() {
    return {
      description: '运行流程表管理页面',
      // 委托单位列表
      weituoClientOptions : [],
      // 委托编号列表
      weituoNoOptions:[],
      // 表头
      columns: [
        {
          title: '#',
          dataIndex: '',
          key: 'rowIndex',
          width: 60,
          align: 'center',
          customRender: function(t, r, index) {
            return parseInt(index) + 1
          }
        },
        // {
        //   title: '流程',
        //   align: 'center',
        //   dataIndex: 'flowPathId_dictText'
        // },
        // {
        //   title: '名称',
        //   align: 'center',
        //   dataIndex: 'name'
        // },
        {
          title: '发起人',
          align: 'center',
          dataIndex: 'faqiUser_dictText'
        },
        {
          title: '委托编号',
          align: 'center',
          dataIndex: 'weituoNo'
        },
        {
          title: '当前步骤',
          align: 'center',
          dataIndex: 'dqSetp_dictText'
        },
        {
          title: '状态',
          align: 'center',
          dataIndex: 'status_dictText'
        },
        {
          title: '操作',
          dataIndex: 'action',
          align: 'center',
          fixed: 'right',
          width: 147,
          scopedSlots: { customRender: 'action' }
        }
      ],
      url: {
        list: '/flowpath/itdmRunFlowPath/list',
        delete: '/flowpath/itdmRunFlowPath/delete',
        deleteBatch: '/flowpath/itdmRunFlowPath/deleteBatch',
        exportXlsUrl: '/flowpath/itdmRunFlowPath/exportXls',
        importExcelUrl: 'flowpath/itdmRunFlowPath/importExcel'

      },
      dictOptions: {},
      superFieldList: []
    }
  },
  created() {
    this.getSuperFieldList()
    this.getClientList();
  },
  computed: {
    importExcelUrl: function() {
      return `${window._CONFIG['domianURL']}/${this.url.importExcelUrl}`
    }
  },
  methods: {
    // 获取委托单位下拉列表
    getClientList(){
      getWeituoClientList().then((res) =>{
        console.log(res)
        this.weituoClientOptions = res.result.map( res => {
          return{
            value: res,
            label: res
          }
        })
      })
    },
    // 监听委托单位获取
    getWeituoClientOptions(value){
      console.log(value);
      console.log(this.queryParam)
      this.weituoNoOptions = []
      this.queryParam.weituoNo = ''
      getWeituoInfoListByClient(this.queryParam).then((res) =>{
        this.weituoNoOptions = res.result.map( res => {
          return{
            value: res.weituoNo,  //传的值
            label: res.weituoNo,  //展示
          }
        })
      })
    },
    // 委托编号赋值
    getWeituoNo(){
      this.queryParam = {...this.queryParam}
    },
    // 搜索
    loadData(arg) {
      if(!this.url.list){
        this.$message.error("请设置url.list属性!")
        return
      }
      //加载数据 若传入参数1则加载第一页的内容
      if (arg === 1) {
        this.ipagination.current = 1;
      }
      var params = this.getQueryParams();//查询条件
      this.loading = true;
      getAction(this.url.list, params).then((res) => {
        if (res.success) {
          //update-begin---author:zhangyafei    Date:20201118  for：适配不分页的数据列表------------
          this.dataSource = res.result.records||res.result;
          this.options =  res.result.records.map(item => {
            return {
              label: item.weituoClient,
              value: item.id,
            };
          });
          if(res.result.total)
          {
            this.ipagination.total = res.result.total;
          }else{
            this.ipagination.total = 0;
          }
          //update-end---author:zhangyafei    Date:20201118  for：适配不分页的数据列表------------
        }else{
          this.$message.warning(res.message)
        }
      }).finally(() => {
        this.loading = false
      })
    },
    // dundun写的
    // tongguo: function(record) {
    //   let that = this

    //   Modal.confirm({
    //     title: '是否通过',
    //     content: '是否通过',
    //     onOk() {
    //       var data = { 'runFlowPath': record.id }
    //       runFlowPathPass1(data).then(response => {
    //         if (response.code == '500') {
    //           that.$message.error(response.message)
    //         }
    //         that.loadData(1);
    //       })
    //     },
    //     onCancel() {},
    //   });


    // },
    // 17写的
    tongguo: function(record) {
      console.log(666,record)
      // 判断下一步是否需要选责任人
      var dataTF = { 'dqStep': record.dqSetp}
      getNextTF(dataTF).then((res) => {
        console.log(res)
        if (res == 1) {
          this.$refs.nextChoose.next(record);
        } else {
          let that = this
          Modal.confirm({
            title: '流程完结',
            content: '该流程是否完结',
            onOk() {
              var data = { 'runFlowPath': record.id }
              runFlowPathPass1(data).then(response => {
                console.log(response)
                if (response.code == '500') {
                  that.$message.error(response.message)
                }
                if (response.code == '200') {
                  // 1.完结时先获取当前id的人员绩效并每条加入完结时间
                  getYeWU({id: record.id}).then((jxRes) => {
                    console.log(11111,jxRes)
                    var stepList = jxRes.result.stepList[4]
                    var jixiaoData = JSON.parse(stepList.saveData).assessmentLog
                    jixiaoData.map(item=>{
                      item.weituoNo = record.weituoNo,
                      item.createTime = jxRes.result.flowpahData.updateTime
                      return item
                    })
                    console.log(jixiaoData)
                    // 2.再通过接口上传人员绩效数据
                    jixiaoPersonPrice(jixiaoData).then(response=> {
                      if (response.success) {
                        // this.$message.success(response.message)
                      } else {
                        that.$message.error(response.message)
                      }
                    })
                  })
                }
                that.loadData(1);
              })
            },
            onCancel() {},
          });
        }
      })
    },
    bohui: function(record) {
      console.log('123123')
      this.$refs.bohuiForm.bohui(record);

    },

    bohui1: function(record) {
      console.log('123123')
      this.$refs.bohuiForm1.bohui(record);

    },
    handleEdit2(record){
      console.log(record)
      this.$router.push({path: '/itdmYeWu/index',query:{id: record.id,flowPathId: record.flowPathId,weituoNo:record.weituoNo}})
    },

    initDictConfig() {
    },
    getSuperFieldList() {
      let fieldList = []
      fieldList.push({ type: 'string', value: 'flowPathId', text: '流程id', dictCode: '' })
      fieldList.push({ type: 'string', value: 'name', text: '名称', dictCode: '' })
      fieldList.push({ type: 'sel_user', value: 'faqiUser', text: '发起人' })
      fieldList.push({ type: 'string', value: 'weituoNo', text: '委托编号', dictCode: '' })
      fieldList.push({ type: 'string', value: 'dqSetp', text: '当前步骤id', dictCode: 'xxx,xxx,xxx' })
      fieldList.push({ type: 'string', value: 'status', text: '状态', dictCode: '' })
      this.superFieldList = fieldList
    },
    // 绩效导出
    exportJX() {
      this.$refs.exportJx.next();
    },
  }
}
</script>
<style scoped>
@import '~@assets/less/common.less';
</style>